----------------------------------------------
-- TelescopeBox.lua
-- by Lygin Gennady a.k.a Croc 26.04.2017. 03.05.2018
---------------------------------------------
require "locale"
require "closeButton"
require "pCXBox"
----------------------------------------------
-- Set initial values
----------------------------------------------
local obs = celestia:getobserver()
local newwidth, newheight
local gn=42
local gg=gn-1
local TelescopeFrameWidth, TelescopeFrameHeight = 170, 14*gn+4
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
TelescopeBox = CXBox:new()
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

TelescopeButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-3, 9)
    :text(_("Tele"))
    :movable(false)
    :visible(false)
    :active(true)
    :attach(TelescopeBox,0,0,0,0)

TelescopeCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-32, 9)
        :text("")
        :movable(false)
        :active(true)
        :attach(TelescopeBox, 20, 0, 0, 0)

TelescopeBox.Customdraw = function(this) -- add this lines by Gironde 08-04-2017
    TelescopeButton.Visible = GuidesVisibility -- display or undisplay Button
    TelescopeCheck.Visible = GuidesVisibility  -- display or undisplay Check
    if TelescopeCheck.Text ==  "o" then
		TelescopeFrame.Visible = GuidesVisibility -- display or undisplay Frame
    end
 end

TelescopeButton.Action = (function()
        return
            function()
              display_Telescope= not display_Telescope
                if display_Telescope then                    				
                    TelescopeFrame.Visible = true                    
                    TelescopeCheck.Text = "o"
                    celestia:seturl("cel://Follow/Sol:Earth/2018-08-30T01:33:09.98159?x=qNQ6ImMQAf///////////w&y=EP9xrYdu&z=MHPOzLVRt////////////w&ow=0.602419&ox=0.00489157&oy=0.798161&oz=-0.00267168&select=Sol:Earth&fov=36.4986&ts=1&ltd=0&p=0&rf=2098579&lm=2178&tsrc=0&ver=3")					
                    celestia:show("stars")
                    celestia:setstarstyle("point")
					else
                    TelescopeFrame.Visible = false                  
                    TelescopeCheck.Text = ""
                    celestia:seturl("cel://Follow/Sol:Earth/2018-08-30T01:33:09.98159?x=qNQ6ImMQAf///////////w&y=EP9xrYdu&z=MHPOzLVRt////////////w&ow=0.602419&ox=0.00489157&oy=0.798161&oz=-0.00267168&select=Sol:Earth&fov=36.4986&ts=1&ltd=0&p=0&rf=2098579&lm=2178&tsrc=0&ver=3")					
                    celestia:show("stars")
                    celestia:setstarstyle("point") 
                end
            end
        end) () 
------------------------------------------------------------------------------------------------------------------------------
TelescopeFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(color83)
    :movable(true)
    :clickable(false)
    :visible(false)
    :attach(screenBox, (width-TelescopeFrameWidth)/2, height-TelescopeFrameHeight-2, (width-TelescopeFrameWidth)/2, 2)

 TelescopeFrame.Customdraw = function(this)

            if Telescope_firstTickDone then
            if not(TelescopeCloseButtonDone) then
                TelescopeCloseButtonDone = true
                makeCloseButton(TelescopeCloseButton, TelescopeFrame, TelescopeButton)
            end
            else
                Telescope_firstTickDone = true
            end

            if newwidth ~= width or newheight ~= height then
                    newwidth, newheight = width, height
               if height>=768  then
                    TelescopeFrame:attach(screenBox, width-TelescopeFrameWidth-36, height-TelescopeFrameHeight-128-27, 36, 128+27)
               else
                    TelescopeFrame:attach(screenBox, width-TelescopeFrameWidth-200, height-TelescopeFrameHeight-3, 200, 3)
               end
            end

	    textlayout:setfont(normalfont)
            textlayout:setfontcolor({0.2,0.8,1,1})
	    textlayout:setpos(this.lb+2, this.tb - 14)
            textlayout:println(_("   Space telescopes, etc.:"))
end
--===============
-- Подключение команд
--===============
Telescope101Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(0, 10)
    :text(_("Country / Cosm. machine / Date:"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-1), 2, 5+14*1)
--=====================
Telescope002Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-2), 129, 5+14*2)

Telescope102Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-2), 49, 5+14*2)

Telescope202Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 114, 2+14*(gg-2), 2, 5+14*2)
--===========================
Telescope003Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-3), 128, 5+14*3)

Telescope103Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(color2)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Hipparcos"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-3), 49, 5+14*3)

Telescope103Box.Action = (function()
    return
        function()
            local obj = celestia:find("Hipparcos")
            celestia:select(obj)
            if not(empty(obj)) then
			   --celestia:seturl("")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope203Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("08-08-89"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-3), 2, 5+14*3)
--===========================
Telescope004Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-4), 128, 5+14*4)

Telescope104Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-4), 49, 5+14*4)

Telescope204Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-4), 2, 5+14*4)
--===========================
Telescope005Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-5), 128, 5+14*5)

Telescope105Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-5), 49, 5+14*5)

Telescope205Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-5), 2, 5+14*5)
--===========================
Telescope006Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("U+E"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-6), 128, 5+14*6)

Telescope106Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Hubble"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-6), 49, 5+14*6)

Telescope106Box.Action = (function()
    return
        function()
           local obj = celestia:find("Hubble")
           celestia:select(obj)
           if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Earth:Hubble/Sol/1990-04-25T02:42:04.13535?x=dr8fBP///////////////w&y=jVyZBQM&z=PI02Xf///////////////w&ow=0.0994122&ox=-0.121152&oy=0.763821&oz=0.626113&track=Sol:Earth:Hubble&select=Sol:Earth:Hubble&fov=107.487&ts=10&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope206Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("24-04-90"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-6), 2, 5+14*6)
--=====================
Telescope007Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-7), 128, 5+14*7)

Telescope107Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Compton GRO"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-7), 49, 5+14*7)
	
Telescope107Box.Action = (function()
    return
        function()
            local obj = celestia:find("Sol/Earth/Compton GRO")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:Compton%20GRO/1991-04-07T01:09:54.52318?x=Lu5Khf7//////////////w&y=kAuBN////////////////w&z=N6x8cv7//////////////w&ow=0.366296&ox=-0.0675816&oy=0.914046&oz=-0.160558&track=Sol:Earth:Compton%20GRO&select=Sol:Earth:Compton%20GRO&fov=107.487&ts=20&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
             end
        end
    end) ()	

Telescope207Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("05-04-91"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-7), 2, 5+14*7)
--==========================
Telescope008Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-8), 128, 5+14*8)

Telescope108Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("ISO"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-8), 49, 5+14*8)

Telescope108Box.Action = (function()
    return
        function()
            local obj = celestia:find("ISO")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:ISO/1995-11-24T03:12:45.26549?x=BIKeWv7//////////////w&y=c88kRA&z=oBZgVA&ow=0.771279&ox=0.0641194&oy=0.63161&oz=0.0456796&track=Sol:Earth:ISO&select=Sol:Earth:ISO&fov=107.487&ts=1000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope208Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("17-11-95"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-8), 2, 5+14*8)
--==========================
Telescope009Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-9), 128, 5+14*9)

Telescope109Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("SWAS"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-9), 49, 5+14*9)

Telescope109Box.Action = (function()
    return
        function()
            local obj = celestia:find("SWAS")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:SWAS/2004-11-22T02:20:01.09489?x=FSRfLAI&y=CbAoGA&z=MayCLQE&ow=0.858957&ox=0.0315806&oy=-0.51083&oz=0.0157624&track=Sol:Earth:SWAS&select=Sol:Earth:SWAS&fov=107.487&ts=10&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope209Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("06-12-98"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-9), 2, 5+14*9)
--=====================
Telescope010Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-10), 128, 5+14*10)

Telescope110Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("TERRIERS"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-10), 49, 5+14*10)

Telescope110Box.Action = (function()
    return
        function()
            local obj = celestia:find("Terriers")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:TERRIERS/1999-05-18T07:31:10.97053?x=EHf+7////////////////w&y=gkZPt////////////////w&z=Ts8eBg&ow=0.583236&ox=-0.435911&oy=0.518658&oz=-0.448119&track=Sol:Earth:TERRIERS&select=Sol:Earth:TERRIERS&fov=107.487&ts=10&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope210Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("18-05-99"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-10), 2, 5+14*10)
--=====================
Telescope011Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-11), 128, 5+14*11)

Telescope111Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("FUSE"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-11), 49, 5+14*11)

Telescope111Box.Action = (function()
    return
        function()
            local obj = celestia:find("FUSE")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:FUSE/1999-06-24T15:51:05.78747?x=cswi5QE&y=jhpBa/7//////////////w&z=KmXpwf///////////////w&ow=0.641596&ox=-0.285147&oy=-0.683807&oz=0.198631&track=Sol:Earth:FUSE&select=Sol:Earth:FUSE&fov=107.487&ts=10&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope211Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("24-06-99"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-11), 2, 5+14*11)
--=====================
Telescope012Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-12), 128, 5+14*12)

Telescope112Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Chandra X-Ray"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-12), 49, 5+14*12)

Telescope112Box.Action = (function()
    return
        function()
            local obj = celestia:find("Chandra")
            celestia:select(obj)
            if not(empty(obj)) then               			
			   celestia:seturl("cel://Follow/Sol:Earth:Chandra/1999-07-23T18:53:12.11783?x=/QAXUf7//////////////w&y=REGjkPv//////////////w&z=7aNib////////////////w&ow=0.362823&ox=-0.604219&oy=-0.440505&oz=0.556089&track=Sol:Earth:Chandra&select=Sol:Earth:Chandra&fov=107.487&ts=800&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)	
            end
        end
    end) ()

Telescope212Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("23-07-99"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-12), 2, 5+14*12)
--=====================
Telescope013Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("E+U"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-13), 128, 5+14*13)

Telescope113Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("XMM-Newton"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-13), 49, 5+14*13)

Telescope113Box.Action = (function()
    return
        function()
            local obj = celestia:find("Sol/Earth/XMM-Newton")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:XMM-Newton/1999-12-12T11:12:29.15761?x=n7PCUQE&y=2mIKFAI&z=COWRSw&ow=0.385406&ox=0.593546&oy=0.296937&oz=0.641087&track=Sol:Earth:XMM-Newton&select=Sol:Earth:XMM-Newton&fov=107.487&ts=2000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()
	
Telescope213Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("10-12-99"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-13), 2, 5+14*13)
--=====================
Telescope014Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-14), 128, 5+14*14)

Telescope114Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-14), 49, 5+14*14)

Telescope214Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-14), 2, 5+14*14)
--=====================
Telescope015Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-15), 128, 5+14*15)

Telescope115Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-15), 49, 5+14*15)

Telescope215Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-15), 2, 5+14*15)
--=====================
Telescope016Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-16), 128, 5+14*16)

Telescope116Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Genesis"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-16), 49, 5+14*16)

Telescope116Box.Action = (function()
    return
        function()
            local obj = celestia:find("Genesis")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Genesis/2004-08-09T15:12:28.08655?x=MgzZ+fz//////////////w&y=mcZXRf///////////////w&z=XKh1k////////////////w&ow=0.652507&ox=-0.0839839&oy=0.748647&oz=-0.0819126&track=Sol:Genesis&select=Sol:Genesis&fov=65.6658&ts=0.5&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)		
            end
        end
    end) ()

Telescope216Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
     :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("08-08-01"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-16), 2, 5+14*16)
--=====================
Telescope017Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-17), 128, 5+14*17)

Telescope117Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Envisat"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-17), 49, 5+14*17)

Telescope117Box.Action = (function()
    return
        function()
            local obj = celestia:find("Envisat")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:EnvisatOrbitFocus:Envisat/2002-03-01T23:13:21.23984?x=X8/vlw4&y=LyaK+////////////////w&z=pKE8xAg&ow=0.86899&ox=-0.0278988&oy=-0.491679&oz=-0.0482674&track=Sol:Earth:EnvisatOrbitFocus:Envisat&select=Sol:Earth:EnvisatOrbitFocus:Envisat&fov=65.6658&ts=4&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.1)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)	
            end
        end
    end) ()

Telescope217Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("01-03-02"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-17), 2, 5+14*17)
--=====================
Telescope018Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-18), 128, 5+14*18)

Telescope118Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("INTEGRAL"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-18), 49, 5+14*18)

Telescope118Box.Action = (function()
    return
        function()
            local obj = celestia:find("Integral")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:INTEGRAL/2002-10-18T07:47:41.98913?x=ZJodDgI&y=ccIUSg&z=ua2z7f///////////////w&ow=0.693287&ox=0.0525992&oy=-0.717247&oz=-0.0462999&track=Sol:Earth:INTEGRAL&fov=65.6658&ts=1000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope218Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("17-10-02"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-18), 2, 5+14*18)
-----------------------------
Telescope019Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("Can"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-19), 128, 5+14*19)

Telescope119Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("MOST"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-19), 49, 5+14*19)

Telescope119Box.Action = (function()
    return
        function()
            local obj = celestia:find("MOST")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:MOST/2003-06-30T14:53:53.80653?x=XDkC9f///////////////w&y=zBtJSw&z=dh69FA&ow=0.793065&ox=0.605034&oy=0.0494232&oz=-0.0503995&track=Sol:Earth:MOST&select=Sol:Earth:MOST&fov=65.6658&ts=20&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope219Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("30-06-03"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-19), 2, 5+14*19)
-----------------------------
Telescope020Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-20), 128, 5+14*20)

Telescope120Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Spitzer S.T."))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-20), 49, 5+14*20)

Telescope120Box.Action = (function()
    return
        function()
            local obj = celestia:find("Spitzer")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Spitzer/2005-04-15T22:14:06.60590?x=HBzvngE&y=4Zm0Cf7//////////////w&z=xZBDbP7//////////////w&ow=0.200946&ox=0.22849&oy=-0.843307&oz=0.442997&track=Sol:Spitzer&select=Sol:Spitzer&fov=65.6658&ts=1e+006&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope220Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("25-08-03"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-20), 2, 5+14*20)
--===========================
Telescope021Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA+"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-21), 128, 5+14*21)

Telescope121Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Swift"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-21), 49, 5+14*21)

Telescope121Box.Action = (function()
    return
        function()
            local obj = celestia:find("Swift")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:Swift/2018-08-14T20:33:07.70812?x=btFHSPz//////////////w&y=GVpo7////////////////w&z=GA8yZf3//////////////w&ow=0.461571&ox=0.00134365&oy=0.887059&oz=-0.00874646&track=Sol:Earth:Swift&select=Sol:Earth:Swift&fov=36.4986&ts=20&ltd=0&p=0&rf=2200979&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope221Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("20-11-04"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-21), 2, 5+14*21)
--======================
Telescope022Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("Jap"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-22), 128, 5+14*22)

Telescope122Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Suzaku"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-22), 49, 5+14*22)
	
 Telescope122Box.Action = (function()
    return
        function()
            local obj = celestia:find("Suzaku")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:Suzaku/2005-07-10T02:12:51.64101?x=Gwrpyvz//////////////w&y=3OjqBw&z=kYZNW/n//////////////w&ow=0.223006&ox=0.00152118&oy=0.974814&oz=0.00180238&track=Sol:Earth:Suzaku&select=Sol:Earth:Suzaku&fov=36.4986&ts=20&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()	

Telescope222Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("10-07-06"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-22), 2, 5+14*22)
--======================
Telescope023Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-23), 128, 5+14*23)

Telescope123Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("STEREO-A +"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-23), 49, 5+14*23)

 Telescope123Box.Action = (function()
    return
        function()
            local obj = celestia:find("STEREO-A")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:STEREO-A/2006-12-01T07:52:35.15242?x=Tc3UDgE&y=OMrU+////////////////w&z=vbSOZ/r//////////////w&ow=0.0932987&ox=-0.00223958&oy=-0.995635&oz=0.0012262&track=Sol:STEREO-A&select=Sol:STEREO-A&fov=36.4986&ts=100000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope223Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("26-10-06"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-23), 2, 5+14*23)
--===========================
Telescope024Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-24), 128, 5+14*24)

Telescope124Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("CoRoT"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-24), 49, 5+14*24)

Telescope124Box.Action = (function()
    return
        function()
            local obj = celestia:find("CoRoT")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:CoRoT/2006-12-27T15:16:48.95437?x=2tphSQM&y=u8HUHP///////////////w&z=IyCU+Ac&ow=0.979624&ox=-0.049782&oy=-0.194172&oz=0.0124734&track=Sol:Earth:CoRoT&select=Sol:Earth:CoRoT&fov=29.7219&ts=25&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope224Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("27-12-06"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-24), 2, 5+14*24)
--===========================
Telescope025Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-25), 128, 5+14*25)

Telescope125Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("FERMI-GLAST"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-25), 49, 5+14*25)
	
Telescope125Box.Action = (function()
    return
        function()
            local obj = celestia:find("FGRST")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Earth:FGRST/2008-06-11T16:54:38.54137?x=LdyuKPz//////////////w&y=W5yXsQM&z=S3HM1////////////////w&ow=0.62503&ox=0.217853&oy=0.68357&oz=0.307587&track=Sol:Earth:FGRST&select=Sol:Earth:FGRST&fov=29.7219&ts=25&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()	

Telescope225Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("11-06-08"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-25), 2, 5+14*25)
--===========================
Telescope026Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-26), 128, 5+14*26)

Telescope126Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Kepler"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-26), 49, 5+14*26)
	
Telescope126Box.Action = (function()
    return
        function()
            local obj = celestia:find("Kepler")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Kepler/2018-08-15T05:59:41.08672?x=Tt0LRA&y=0atg&z=u+y+8f///////////////w&ow=0.630466&ox=0.00421707&oy=-0.776205&oz=-7.34755e-005&track=Sol:Kepler&select=Sol:Kepler&fov=120&ts=1&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()	

Telescope226Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("06-03-09"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-26), 2, 5+14*26)
--===========================
Telescope027Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-27), 128, 5+14*27)

Telescope127Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Herschel"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-27), 49, 5+14*27)

 Telescope127Box.Action = (function()
    return
        function()
            local obj = celestia:find("Herschel")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Herschel/2009-07-11T00:51:52.25296?x=f1DMFgU&y=ATgaqwM&z=wp7XwAU&ow=0.870927&ox=0.324504&oy=-0.23822&oz=0.281839&track=Sol:Herschel&select=Sol:Herschel&fov=29.7219&ts=100000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope227Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("14-05-09"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-27), 2, 5+14*27)
--=====================
Telescope028Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-28), 128, 5+14*28)

Telescope128Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Planck"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-28), 49, 5+14*28)

 Telescope128Box.Action = (function()
    return
        function()
            local obj = celestia:find("Planck")
            celestia:select(obj)
            if not(empty(obj)) then
   			   celestia:seturl("cel://Follow/Sol:Planck/2009-05-14T13:56:02.59667?x=kWEHf/3//////////////w&y=YJNKsv3//////////////w&z=s3FXW/v//////////////w&ow=0.158396&ox=0.274078&oy=0.910054&oz=-0.26757&track=Sol:Planck&select=Sol:Planck&fov=29.7219&ts=20&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope228Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("14-05-09"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-28), 2, 5+14*28)
--===========================
Telescope029Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-29), 128, 5+14*29)

Telescope129Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-29), 49, 5+14*29)

Telescope229Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-29), 2, 5+14*29)
--======================
Telescope030Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-30), 128, 5+14*30)

Telescope130Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-30), 49, 5+14*30)

Telescope230Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-30), 2, 5+14*30)	
--=====================
Telescope031Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-31), 128, 5+14*31)

Telescope131Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("SDO"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-31), 49, 5+14*31)

Telescope131Box.Action = (function()
    return
        function()
            local obj = celestia:find("sdo")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Earth:SDO/Sol:Earth/2010-02-12T04:49:00.90888?x=4FZNBPz//////////////w&y=KbyrngE&z=xJzWy/7//////////////w&ow=-0.36959&ox=0.400377&oy=-0.688832&oz=-0.478134&track=Sol:Earth:SDO&select=Sol:Earth:SDO&fov=51.7996&ts=1000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.9)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope231Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("11-02-10"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-31), 2, 5+14*31)
--=====================
Telescope032Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USSR"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-32), 128, 5+14*32)

Telescope132Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Spektr-R"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-32), 49, 5+14*32)

Telescope132Box.Action = (function()
    return
        function()
            local obj = celestia:find("Spektr-R")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Earth:Spektr-R/2011-07-20T14:16:28.59429?x=MnZj2f7//////////////w&y=qOa+cg&z=Ci/80QM&ow=0.987736&ox=0.0548022&oy=0.145741&oz=0.0115944&track=Sol:Earth:Spektr-R&select=Sol:Earth:Spektr-R&fov=120&ts=4000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope232Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("18-07-11"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-32), 2, 5+14*32)
--===========================
Telescope033Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-33), 128, 5+14*33)

Telescope133Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("IRIS"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-33), 49, 5+14*33)

Telescope133Box.Action = (function()
    return
        function()
           local obj = celestia:find("IRIS (sat)")
           celestia:select(obj)
           if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Earth:IRIS%20(sat)/Sol:Earth/2013-06-27T03:01:43.53523?x=QBGoFA&y=qKPaW////////////////w&z=LgNRjv///////////////w&ow=0.424058&ox=-0.84526&oy=0.262114&oz=-0.192371&track=Sol:Earth:IRIS%20(sat)&select=Sol:Earth:IRIS%20(sat)&fov=120&ts=20&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope233Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("27-06-13"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-33), 2, 5+14*33)
--===========================
Telescope034Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-34), 128, 5+14*34)

Telescope134Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(color2)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("Gaia"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-34), 49, 5+14*34)

Telescope134Box.Action = (function()
    return
        function()
            local obj = celestia:find("Gaia")
            celestia:select(obj)
            if not(empty(obj)) then
               tdb_dt = celestia:utctotdb(2013, 19, 10, 9, 12, 00)
               celestia:settime(tdb_dt)
              -- obs:chase(obj)
			   obs:follow(obj)
               obs:goto(obj)
               celestia:settimescale(4)
            end
        end
    end) ()

Telescope234Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("19-12-13"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-34), 2, 5+14*34)
--===========================
Telescope035Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("ESA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-35), 128, 5+14*35)

Telescope135Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("LISA Pathfinder"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-35), 49, 5+14*35)

Telescope135Box.Action = (function()
    return
        function()
            local obj = celestia:find("LISA Pathfinder")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Chase/Sol:Earth:LISA%20Pathfinder/2016-04-16T03:00:55.93991?x=Qz67MgE&y=nhsmFg&z=y1navP///////////////w&ow=-0.624717&ox=-0.124509&oy=0.768867&oz=-0.0554071&track=Sol:Earth:LISA%20Pathfinder&select=Sol:Earth:LISA%20Pathfinder&fov=120&ts=80000&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope235Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("03-12-15"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-35), 2, 5+14*35)
--=====================
Telescope036Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-36), 128, 5+14*36)

Telescope136Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("TESS"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-36), 49, 5+14*36)

Telescope136Box.Action = (function()
    return
        function()
            local obj = celestia:find("Sol/Earth/TESS")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Earth:TESS/Sol:Earth/2019-01-06T13:06:24.46079?x=zh5IM+7//////////////w&y=ZlzMKP///////////////w&z=DE2ewv///////////////w&ow=0.482131&ox=-0.517252&oy=0.482131&oz=0.517252&track=Sol:Earth&select=Sol:Earth:TESS&fov=5.37446&ts=500&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()

Telescope236Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("18-04-18"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-36), 2, 5+14*36)
--============================
Telescope037Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-37), 128, 5+14*37)

Telescope137Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-37), 49, 5+14*37)

Telescope237Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-37), 2, 5+14*37)	
--=====================
Telescope038Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-38), 128, 5+14*38)

Telescope138Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-38), 49, 5+14*38)

Telescope238Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-38), 2, 5+14*38)	
--=====================
Telescope039Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 2, 2+14*(gg-39), 128, 5+14*39)

Telescope139Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_("James Webb"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-39), 49, 5+14*39)
	
Telescope139Box.Action = (function()
    return
        function()
           local obj = celestia:find("Sol/Earth/James Webb ST")
            celestia:select(obj)
            if not(empty(obj)) then
			   celestia:seturl("cel://Chase/Sol:Earth:James%20Webb%20ST/2018-06-18T12:03:54.52116?x=VkGr/AE&y=IqG3kQ&z=xgI13vr//////////////w&ow=0.182879&ox=0.520344&oy=-0.83249&oz=0.0525156&track=Sol:Earth:James%20Webb%20ST&select=Sol:Earth:James%20Webb%20ST&fov=120&ts=1&ltd=0&p=0&rf=2135443&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.6)			   
               celestia:setorbitflags{Moon = true} -- луны			   
               obs:center(obj)
            end
        end
    end) ()
	
Telescope239Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-4, 10)
    :text(_("   ~2020"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-39), 2, 5+14*39)
--===================================
Telescope040Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_("USA+"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-40), 128, 5+14*40)

Telescope140Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(color2)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("LISA"))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-40), 49, 5+14*40)

Telescope140Box.Action = (function()
    return
        function()
            local obj = celestia:find("LISA")
            celestia:select(obj)
            if not(empty(obj)) then
               tdb_dt = celestia:utctotdb(2004, 11, 22, 02, 02, 00) 
               celestia:settime(tdb_dt)
               obs:follow(obj)
               obs:goto(obj)
               celestia:settimescale(50)
            end
        end
    end) ()

Telescope240Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_("  ~2029"))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-40), 2, 5+14*40)
--============================
Telescope041Box = CXBox:new()
    :init(0, 0, 0, 0) 
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 2, 2+14*(gg-41), 128, 5+14*41)

Telescope141Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(true)
    :attach(TelescopeFrame, 44, 2+14*(gg-41), 49, 5+14*41)

Telescope241Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(-2, 10)
    :text(_(""))
    :movable(false)
    :active(false)
    :attach(TelescopeFrame, 123, 2+14*(gg-41), 2, 5+14*41)	
--============================
	